# coding: utf-8

"""
    SCORM Cloud Rest API

    REST API used for SCORM Cloud integrations.

    OpenAPI spec version: 2.0
    Contact: systems@rusticisoftware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class CourseActivitySchema(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, external_identifier=None, item_identifier=None, resource_identifier=None, activity_type=None, href=None, scaled_passing_score=None, title=None, children=None):
        """
        CourseActivitySchema - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'external_identifier': 'str',
            'item_identifier': 'str',
            'resource_identifier': 'str',
            'activity_type': 'str',
            'href': 'str',
            'scaled_passing_score': 'str',
            'title': 'str',
            'children': 'list[CourseActivitySchema]'
        }

        self.attribute_map = {
            'external_identifier': 'externalIdentifier',
            'item_identifier': 'itemIdentifier',
            'resource_identifier': 'resourceIdentifier',
            'activity_type': 'activityType',
            'href': 'href',
            'scaled_passing_score': 'scaledPassingScore',
            'title': 'title',
            'children': 'children'
        }

        self._external_identifier = external_identifier
        self._item_identifier = item_identifier
        self._resource_identifier = resource_identifier
        self._activity_type = activity_type
        self._href = href
        self._scaled_passing_score = scaled_passing_score
        self._title = title
        self._children = children

    @property
    def external_identifier(self):
        """
        Gets the external_identifier of this CourseActivitySchema.
        An arbitrary identifier that the external LMS system can associate with this LearningObject to track it as it isreused across courses 

        :return: The external_identifier of this CourseActivitySchema.
        :rtype: str
        """
        return self._external_identifier

    @external_identifier.setter
    def external_identifier(self, external_identifier):
        """
        Sets the external_identifier of this CourseActivitySchema.
        An arbitrary identifier that the external LMS system can associate with this LearningObject to track it as it isreused across courses 

        :param external_identifier: The external_identifier of this CourseActivitySchema.
        :type: str
        """

        self._external_identifier = external_identifier

    @property
    def item_identifier(self):
        """
        Gets the item_identifier of this CourseActivitySchema.
        The string which identifies this activity in the context of its course

        :return: The item_identifier of this CourseActivitySchema.
        :rtype: str
        """
        return self._item_identifier

    @item_identifier.setter
    def item_identifier(self, item_identifier):
        """
        Sets the item_identifier of this CourseActivitySchema.
        The string which identifies this activity in the context of its course

        :param item_identifier: The item_identifier of this CourseActivitySchema.
        :type: str
        """

        self._item_identifier = item_identifier

    @property
    def resource_identifier(self):
        """
        Gets the resource_identifier of this CourseActivitySchema.
        The string which identifies this activity's resource in a course's manifest

        :return: The resource_identifier of this CourseActivitySchema.
        :rtype: str
        """
        return self._resource_identifier

    @resource_identifier.setter
    def resource_identifier(self, resource_identifier):
        """
        Sets the resource_identifier of this CourseActivitySchema.
        The string which identifies this activity's resource in a course's manifest

        :param resource_identifier: The resource_identifier of this CourseActivitySchema.
        :type: str
        """

        self._resource_identifier = resource_identifier

    @property
    def activity_type(self):
        """
        Gets the activity_type of this CourseActivitySchema.
        The type of activity this is

        :return: The activity_type of this CourseActivitySchema.
        :rtype: str
        """
        return self._activity_type

    @activity_type.setter
    def activity_type(self, activity_type):
        """
        Sets the activity_type of this CourseActivitySchema.
        The type of activity this is

        :param activity_type: The activity_type of this CourseActivitySchema.
        :type: str
        """
        allowed_values = ["UNKNOWN", "AGGREGATION", "SCO", "ASSET", "OBJECTIVE"]
        if activity_type not in allowed_values:
            raise ValueError(
                "Invalid value for `activity_type` ({0}), must be one of {1}"
                .format(activity_type, allowed_values)
            )

        self._activity_type = activity_type

    @property
    def href(self):
        """
        Gets the href of this CourseActivitySchema.
        The web path used to launch this activity

        :return: The href of this CourseActivitySchema.
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """
        Sets the href of this CourseActivitySchema.
        The web path used to launch this activity

        :param href: The href of this CourseActivitySchema.
        :type: str
        """

        self._href = href

    @property
    def scaled_passing_score(self):
        """
        Gets the scaled_passing_score of this CourseActivitySchema.
        The score required of a learner to pass this activity

        :return: The scaled_passing_score of this CourseActivitySchema.
        :rtype: str
        """
        return self._scaled_passing_score

    @scaled_passing_score.setter
    def scaled_passing_score(self, scaled_passing_score):
        """
        Sets the scaled_passing_score of this CourseActivitySchema.
        The score required of a learner to pass this activity

        :param scaled_passing_score: The scaled_passing_score of this CourseActivitySchema.
        :type: str
        """

        self._scaled_passing_score = scaled_passing_score

    @property
    def title(self):
        """
        Gets the title of this CourseActivitySchema.
        The title of the activity

        :return: The title of this CourseActivitySchema.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """
        Sets the title of this CourseActivitySchema.
        The title of the activity

        :param title: The title of this CourseActivitySchema.
        :type: str
        """

        self._title = title

    @property
    def children(self):
        """
        Gets the children of this CourseActivitySchema.

        :return: The children of this CourseActivitySchema.
        :rtype: list[CourseActivitySchema]
        """
        return self._children

    @children.setter
    def children(self, children):
        """
        Sets the children of this CourseActivitySchema.

        :param children: The children of this CourseActivitySchema.
        :type: list[CourseActivitySchema]
        """

        self._children = children

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CourseActivitySchema):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
