# coding: utf-8

"""
    SCORM Cloud Rest API

    REST API used for SCORM Cloud integrations.

    OpenAPI spec version: 2.0
    Contact: systems@rusticisoftware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PublicInvitationSchema(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, id=None, course_id=None, allow_launch=None, allow_new_registrations=None, url=None, create_date=None, updated=None, post_back=None, expiration_date=None, registration_cap=0, registration_count=None):
        """
        PublicInvitationSchema - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'course_id': 'str',
            'allow_launch': 'bool',
            'allow_new_registrations': 'bool',
            'url': 'str',
            'create_date': 'datetime',
            'updated': 'datetime',
            'post_back': 'PostBackSchema',
            'expiration_date': 'datetime',
            'registration_cap': 'int',
            'registration_count': 'int'
        }

        self.attribute_map = {
            'id': 'id',
            'course_id': 'courseId',
            'allow_launch': 'allowLaunch',
            'allow_new_registrations': 'allowNewRegistrations',
            'url': 'url',
            'create_date': 'createDate',
            'updated': 'updated',
            'post_back': 'postBack',
            'expiration_date': 'expirationDate',
            'registration_cap': 'registrationCap',
            'registration_count': 'registrationCount'
        }

        self._id = id
        self._course_id = course_id
        self._allow_launch = allow_launch
        self._allow_new_registrations = allow_new_registrations
        self._url = url
        self._create_date = create_date
        self._updated = updated
        self._post_back = post_back
        self._expiration_date = expiration_date
        self._registration_cap = registration_cap
        self._registration_count = registration_count

    @property
    def id(self):
        """
        Gets the id of this PublicInvitationSchema.
        The invitationId for this invitation.

        :return: The id of this PublicInvitationSchema.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this PublicInvitationSchema.
        The invitationId for this invitation.

        :param id: The id of this PublicInvitationSchema.
        :type: str
        """

        self._id = id

    @property
    def course_id(self):
        """
        Gets the course_id of this PublicInvitationSchema.
        Course Id for this Invitation.

        :return: The course_id of this PublicInvitationSchema.
        :rtype: str
        """
        return self._course_id

    @course_id.setter
    def course_id(self, course_id):
        """
        Sets the course_id of this PublicInvitationSchema.
        Course Id for this Invitation.

        :param course_id: The course_id of this PublicInvitationSchema.
        :type: str
        """

        self._course_id = course_id

    @property
    def allow_launch(self):
        """
        Gets the allow_launch of this PublicInvitationSchema.
        If true, then new registrations can be created for this dispatch.

        :return: The allow_launch of this PublicInvitationSchema.
        :rtype: bool
        """
        return self._allow_launch

    @allow_launch.setter
    def allow_launch(self, allow_launch):
        """
        Sets the allow_launch of this PublicInvitationSchema.
        If true, then new registrations can be created for this dispatch.

        :param allow_launch: The allow_launch of this PublicInvitationSchema.
        :type: bool
        """

        self._allow_launch = allow_launch

    @property
    def allow_new_registrations(self):
        """
        Gets the allow_new_registrations of this PublicInvitationSchema.
        If true, then new registrations can be created for this dispatch.

        :return: The allow_new_registrations of this PublicInvitationSchema.
        :rtype: bool
        """
        return self._allow_new_registrations

    @allow_new_registrations.setter
    def allow_new_registrations(self, allow_new_registrations):
        """
        Sets the allow_new_registrations of this PublicInvitationSchema.
        If true, then new registrations can be created for this dispatch.

        :param allow_new_registrations: The allow_new_registrations of this PublicInvitationSchema.
        :type: bool
        """

        self._allow_new_registrations = allow_new_registrations

    @property
    def url(self):
        """
        Gets the url of this PublicInvitationSchema.
        The launch URL for the invitation

        :return: The url of this PublicInvitationSchema.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """
        Sets the url of this PublicInvitationSchema.
        The launch URL for the invitation

        :param url: The url of this PublicInvitationSchema.
        :type: str
        """

        self._url = url

    @property
    def create_date(self):
        """
        Gets the create_date of this PublicInvitationSchema.
        The create date for the invitation

        :return: The create_date of this PublicInvitationSchema.
        :rtype: datetime
        """
        return self._create_date

    @create_date.setter
    def create_date(self, create_date):
        """
        Sets the create_date of this PublicInvitationSchema.
        The create date for the invitation

        :param create_date: The create_date of this PublicInvitationSchema.
        :type: datetime
        """

        self._create_date = create_date

    @property
    def updated(self):
        """
        Gets the updated of this PublicInvitationSchema.

        :return: The updated of this PublicInvitationSchema.
        :rtype: datetime
        """
        return self._updated

    @updated.setter
    def updated(self, updated):
        """
        Sets the updated of this PublicInvitationSchema.

        :param updated: The updated of this PublicInvitationSchema.
        :type: datetime
        """

        self._updated = updated

    @property
    def post_back(self):
        """
        Gets the post_back of this PublicInvitationSchema.
        Specifies a URL for which to post activity and status data in real time as the course is completed

        :return: The post_back of this PublicInvitationSchema.
        :rtype: PostBackSchema
        """
        return self._post_back

    @post_back.setter
    def post_back(self, post_back):
        """
        Sets the post_back of this PublicInvitationSchema.
        Specifies a URL for which to post activity and status data in real time as the course is completed

        :param post_back: The post_back of this PublicInvitationSchema.
        :type: PostBackSchema
        """

        self._post_back = post_back

    @property
    def expiration_date(self):
        """
        Gets the expiration_date of this PublicInvitationSchema.
        The date this invitation will expire and can not be launched (formatted yyyyMMddHHmmss in UTC time).

        :return: The expiration_date of this PublicInvitationSchema.
        :rtype: datetime
        """
        return self._expiration_date

    @expiration_date.setter
    def expiration_date(self, expiration_date):
        """
        Sets the expiration_date of this PublicInvitationSchema.
        The date this invitation will expire and can not be launched (formatted yyyyMMddHHmmss in UTC time).

        :param expiration_date: The expiration_date of this PublicInvitationSchema.
        :type: datetime
        """

        self._expiration_date = expiration_date

    @property
    def registration_cap(self):
        """
        Gets the registration_cap of this PublicInvitationSchema.
        Integer value that limits the amount of registrations a public invitation can generate.

        :return: The registration_cap of this PublicInvitationSchema.
        :rtype: int
        """
        return self._registration_cap

    @registration_cap.setter
    def registration_cap(self, registration_cap):
        """
        Sets the registration_cap of this PublicInvitationSchema.
        Integer value that limits the amount of registrations a public invitation can generate.

        :param registration_cap: The registration_cap of this PublicInvitationSchema.
        :type: int
        """

        self._registration_cap = registration_cap

    @property
    def registration_count(self):
        """
        Gets the registration_count of this PublicInvitationSchema.
        The count of registrations for this invitation

        :return: The registration_count of this PublicInvitationSchema.
        :rtype: int
        """
        return self._registration_count

    @registration_count.setter
    def registration_count(self, registration_count):
        """
        Sets the registration_count of this PublicInvitationSchema.
        The count of registrations for this invitation

        :param registration_count: The registration_count of this PublicInvitationSchema.
        :type: int
        """

        self._registration_count = registration_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PublicInvitationSchema):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
